codeforces 461C

这题说的是 给了一张长方形的纸 1*n 然后可以按照不同的做法去折这个纸张 他有两种操作,操作1 给了一个pi 点 然后将左边的纸往右边折,第2种操作是给了一个L 和 R 然后计算出 L和R 之间的纸如果 切成单位长度有多少块, 开一个标记数组记录方向然后枚举将每位的值复制到相对应的地方,然后用树状数组不断地去维护,记得如果切的点在目前的最左区间和最右区间的二分一靠右的地方那么记得折的变成右边方向记得记录一下,然后再同样的用树状数组去维护

#include <iostream>
#include <cstdio>
#include <string.h>
using namespace std;
const int MAX_N = 100005;
int C[MAX_N],n;
int lowbit(int x){
  return x&(-x);
}
int sum(int x){
    int ans =0;
    while(x>0){
        ans+= C[x];
        x-=lowbit(x);
    }
   return ans;
}
void add(int x, int d){
    while(x<=n){
         C[x]+=d;
         x+=lowbit(x);
    }
}
int main()
{
       int q,L,R,turn=0;
       scanf("%d%d",&n,&q);
      R = n,L=0;
       for(int i=1 ; i<=n; i++)
         add(i,1);
       for(int cc=0 ; cc< q; ++cc){

           int op,a,b;
           scanf("%d",&op);
           if(op==1){
              scanf("%d",&a);
              int Len = R -L;
              if( ( a>Len/2 && turn==0 ) ){
                    int LEN = Len-a;
                    a = R-LEN;
                  for(int loc = 1; loc <= LEN; ++loc ){
                       int E = sum( a+loc ) - sum(a+loc-1);
                       add(a-loc+1,E);
                  }
                  turn=1;
                  R = a;
                  continue;
              }
              if( (a<=Len/2 &&turn == 1 ) ){
                   int LEN = a;
                   a = R - LEN;
                  for(int loc =1 ;loc <= LEN; ++loc){

                      int E = sum(a+loc) -sum(a+loc-1);
                      add(a-loc+1,E);
                  }
                  R=a;
                  continue;
              }
              if( (a>(Len/2)&& turn==1)){
                   int LEN = Len - a;
                    a = L+LEN;
                   for(int loc =0; loc < LEN ; ++loc){
                        int E = sum( a - loc ) -sum(a-loc-1);
                        add(a+loc+1,E);
                   }
                   L=a;
                   turn=0;
                   continue;
              }
              if(a<=Len/2 && turn == 0 ){
                   int LEN = a;
                   a=L+a;
                   for(int loc =0 ; loc <LEN; ++ loc){
                        int E = sum(a-loc) -sum(a-loc -1);
                        add(a+loc+1,E);
                   }
                  L=a;
                  continue;
              }
           }else{
               scanf("%d%d",&a,&b);
                int ans;
               if(turn==0){
                ans = sum(L+b)-sum(L+a);
               }else {
                  ans = sum(R-a) -sum(R-b);
               }
               printf("%d\n",ans);
           }

        }

       return 0;
}

时间: 2024-10-12 15:15:20

codeforces 461C的相关文章

Codeforces 461C Appleman and a Sheet of Paper(模拟)

题目链接:Codeforces 461C Appleman and a Sheet of Paper 题目大意:就是一个叠被子的过程,穿插着询问一段区间上被子的单位厚度. 解题思路:用前缀和数组模拟即可.因为对于折超过一半的处理为将令一半叠上来,所以需要变量记录当前被子的正反状态.处理好下标关系即可. #include <cstdio> #include <cstring> #include <algorithm> using namespace std; const

Codeforces 461C. Appleman and a Sheet of Paper

每次只把短的部分往长的部分折叠,直接用树状数组爆搞就可以了. 每次长度都缩小一些暴力的复杂度不是太高,启发式暴力???? C. Appleman and a Sheet of Paper time limit per test 2 seconds memory limit per test 256 megabytes input standard input output standard output Appleman has a very big sheet of paper. This s

【codeforces 718E】E. Matvey&#39;s Birthday

题目大意&链接: http://codeforces.com/problemset/problem/718/E 给一个长为n(n<=100 000)的只包含‘a’~‘h’8个字符的字符串s.两个位置i,j(i!=j)存在一条边,当且仅当|i-j|==1或s[i]==s[j].求这个无向图的直径,以及直径数量. 题解:  命题1:任意位置之间距离不会大于15. 证明:对于任意两个位置i,j之间,其所经过每种字符不会超过2个(因为相同字符会连边),所以i,j经过节点至多为16,也就意味着边数至多

Codeforces 124A - The number of positions

题目链接:http://codeforces.com/problemset/problem/124/A Petr stands in line of n people, but he doesn't know exactly which position he occupies. He can say that there are no less than a people standing in front of him and no more than b people standing b

Codeforces 841D Leha and another game about graph - 差分

Leha plays a computer game, where is on each level is given a connected graph with n vertices and m edges. Graph can contain multiple edges, but can not contain self loops. Each vertex has an integer di, which can be equal to 0, 1 or  - 1. To pass th

Codeforces Round #286 (Div. 1) A. Mr. Kitayuta, the Treasure Hunter DP

链接: http://codeforces.com/problemset/problem/506/A 题意: 给出30000个岛,有n个宝石分布在上面,第一步到d位置,每次走的距离与上一步的差距不大于1,问走完一路最多捡到多少块宝石. 题解: 容易想到DP,dp[i][j]表示到达 i 处,现在步长为 j 时最多收集到的财富,转移也不难,cnt[i]表示 i 处的财富. dp[i+step-1] = max(dp[i+step-1],dp[i][j]+cnt[i+step+1]) dp[i+st

Codeforces 772A Voltage Keepsake - 二分答案

You have n devices that you want to use simultaneously. The i-th device uses ai units of power per second. This usage is continuous. That is, in λ seconds, the device will use λ·ai units of power. The i-th device currently has bi units of power store

Educational Codeforces Round 21 G. Anthem of Berland(dp+kmp)

题目链接:Educational Codeforces Round 21 G. Anthem of Berland 题意: 给你两个字符串,第一个字符串包含问号,问号可以变成任意字符串. 问你第一个字符串最多包含多少个第二个字符串. 题解: 考虑dp[i][j],表示当前考虑到第一个串的第i位,已经匹配到第二个字符串的第j位. 这样的话复杂度为26*n*m*O(fail). fail可以用kmp进行预处理,将26个字母全部处理出来,这样复杂度就变成了26*n*m. 状态转移看代码(就是一个kmp

Codeforces Round #408 (Div. 2) B

Description Zane the wizard is going to perform a magic show shuffling the cups. There are n cups, numbered from 1 to n, placed along the x-axis on a table that has m holes on it. More precisely, cup i is on the table at the position x?=?i. The probl